# -*- coding: utf-8 -*-

import time
import string

def parse_input(inputstr):
    
    """parseInput(inputstr) -> {timestamp, dalek1_position,
    dalek2_position, ball_position}

    Parse data from an input layer -- in our case, a fake layer"""
    
    try:
        (timestamp, khep_coord0, khep_coord1, ball_coord) = inputstr.split()
    except ValueError:
        return None
		
    khep_coord0 = string.split(khep_coord0, ',')
    khep_coord1 = string.split(khep_coord1, ',')
    ball_coord = string.split(ball_coord, ',')
    info = {}
    info["timestamp"] = int(timestamp)
    info["ball_coord"] = (int(ball_coord[0]), int(ball_coord[1]))
    info["khep_coord"] = {}
    info["khep_coord"][0] = (int(khep_coord0[0]), int(khep_coord0[1]), int(khep_coord0[2]))
    info["khep_coord"][1] = (int(khep_coord1[0]), int(khep_coord1[1]), int(khep_coord1[2]))
    return info


class Coordinate:
    
    """Fake input from RIE or SONERE so we can test BUT.
    
    Read from a file fake data from input layers (RIE or SONERE). The
    data ought to be presented thus :
    
    [timestamp] [khep_coord0] [khep_coord1] [ball_coord]
    where [khep_coord0] = x,y,angle
    ..."""
    
    def __init__(self, filename):
        
        self.file = open(filename)
        self.currentline = 1
        """self.currentdata = {}
        self.nextdata = {}
        self.inittime = time.time()"""
        
    def get_info(self, timestamp):
        
        """ Return the currently available data as a hash, or None if end of
        feed """
        
        """if len(self.currentdata) == 0:
            # if no data yet (first read), update the current values
            self.currentdata = parse_input(self.file.readline())
            self.nextdata = parse_input(self.file.readline())
        else:
            if self.nextdata and float(self.nextdata["timestamp"])\
                    < time.time() - self.inittime:
                # if data outdated, update the next value
                self.currentdata = self.nextdata
                self.nextdata = parse_input(self.file.readline())
            else:
                if self.nextdata is None:
                    self.currentdata = None
        return self.currentdata"""
        line = self.file.readline()
        data = parse_input(line)
        return data
