import Pyro.core
import sys
from threading import Thread
from Queue import Queue

#get me from with a real config object 
serial_config = {
    #   id_khep : serial id
        1: "toto",
        2: "bob",
    }

if len(sys.argv) <= 1:
    print >> sys.stderr, "usage: python server.py <port>"
    sys.exit(1)

server_port = int(sys.argv[1])

class SoyaSocket(Pyro.core.ObjBase):
    def __init__(self, serial_port):
        Pyro.core.ObjBase.__init__(self)
        self.serial_port = serial_port
        self. input = Queue()
        self.output = Queue()

    def read(self):
        #XXX This must be thread safe
        return self.output.get()

    def write(self, data):
        #XXX This must be thread safe
        self.input.put(data)

Pyro.core.initServer()
pyro_server = Pyro.core.Daemon(port=server_port)

all_serial = {}
for khep_id, serial_id in serial_config.iteritems():
    serial = SoyaSocket(serial_id)
    uri = "serials/%s" % serial_id
    pyro_server.connect(serial, uri)
    print "khep %s have is serial served here %s" % (khep_id, serial_id)
    all_serial[khep_id] = serial


try:
    server_thread = Thread(target=pyro_server.requestLoop, name="pyro_main")
    server_thread.start()
    all_serial[1].output.put("message from outer space")
    print "1:", all_serial[1].input.get()
    print "1:", all_serial[1].input.get()
    print "2:", all_serial[2].input.get()

    raw_input("server started, press enter to close it")
finally:
    pyro_server.shutdown(True)
