"""This module contains Mock Classes for users of standards  scor interface.

Those objects are intended for testing.
"""
from time import sleep

class AutomatedControlClient(object):
    """Automated client for Control interface."""

    # A class is not really required here but this may be extend to something
    # more powerfull where you can crash your call sequence.

    def __init__(self, control, robots_ids):
        self.control = control
        self.robots_ids = robots_ids

    def run(self, delay=0, verbose=False):
        """make a sequence of various call to control interface"""

        robots_ids = self.robots_ids
        # Stop all
        if verbose:
            print "stop"
        for ident in robots_ids:
            self.control.stop(ident)
        try:

            sleep(delay)

            # Turn
            switch = 1
            if verbose:
                print "turn"
            for ident in robots_ids:
                self.control.rotate(ident, switch)
                switch *= -1

            sleep(delay)

            # Turn
            switch = -1
            if verbose:
                print "turn"
            for ident in robots_ids:
                self.control.rotate(ident, switch)
                switch *= -1

            sleep(delay)

            # forward
            if verbose:
                print "forward"
            for ident in robots_ids:
                self.control.move(ident, 1)

            sleep(delay)

            # Backward
            if verbose:
                print "backward"
            for ident in robots_ids:
                self.control.move(ident, -1)

            sleep(delay)

        finally: #try to alway leave robot on hold
            # Stop all
            if verbose:
                print "stop"
            for ident in robots_ids:
                self.control.stop(ident)

