# -*- coding:utf-8 -*-
"""
This module provides a serial-like wrapper. It is designed for testing purpose
only.
"""
from Queue import Queue
from time import gmtime, strftime

from scor.common.interfaces import IKheperaSerial

class Wrapper(IKheperaSerial):
    """
    This class defines a serial-like wrapper. It only stores the passed message
    in a queue, and prints it to /dev/stdout at the moment.
    """

    def __init__(self, port):
        """
        Initializes the fake serial.
        """
        IKheperaSerial.__init__(self)
        self.port = port
        self.queue = Queue(-1)

    def write(self, msg):
        """
        Write msg to the serial connection.
        """
        time = strftime("%a, %d %b %Y %H:%M:%S +0000", gmtime())
        self.queue.put_nowait(msg)
        print "%s (%s) -> %s" % (self.port, time, msg)

class SerialHub(IKheperaSerial):
    """
    def __init__(self, serials_like):

    group several serial_like object and sent any write order to all of them

    """
    def __init__(self, serials_like):
        self._all = serials_like

    def write(self, msg):
        for serial in self._all:
            serial.write(msg)

# vim: ts=4
